﻿// Copyright (c) 2006 Google Inc.
// All rights reserved
// 
// This file is part of the Google Desktop SDK and may be freely copied and used.
// To download the latest version of the SDK please visit 
// http://desktop.google.com/developer.html

view.caption = strTitle;
contentArea.contentFlags = gddContentFlagHaveDetails;

// default/initial settings
thee_url = "http://www.b4u.com/rss/en_good_life.xml";

setInterval(OnTimer, 1000 * 3600);  // check once every hour
OnTimer();    // update with first set of items


function showDlg() {
	return false;
}

function GetUrls() {
  
  var arr = new Array();
  var url = "http://www.b4u.com/rss/en_good_life.xml";
  arr.push(url);

  return arr;
}



function OnTimer() {
  // issue requests for all our URLs

    var item = new WordItem(thee_url);
    item = null;

}

function TrimString(str) {
  str = str.replace( /^\s+/g, "" );   // strip leading whitespaces
  return str.replace( /\s+$/g, "" );  // strip trailing whitespaces
}

function GetDomainName(url) {
  var i;
  if ((i = url.indexOf("//")) != -1)
    url = url.substring(i + 2);
  if ((i = url.indexOf("/")) != -1)
    url = url.substring(0, i);
  var firstDot = url.indexOf(".");
  var secondDot = url.indexOf(".", firstDot + 1);
  while ((i = url.indexOf(".", secondDot + 1)) != -1) {
    firstDot = secondDot;
    secondDot = i;
  }
  if (firstDot != -1 && secondDot != -1) {
    return url.substring(firstDot + 1);
  }
}


//---- A class to manage the requests and callbacks of an item
function WordItem(url) {
  

  // send request to webserver for data
  var source = GetDomainName(url);
  var http = new XMLHttpRequest();
  http.onreadystatechange = OnData;
  http.open("GET", url, true);
  http.send();

  function OnData() {

    //alert("readyState" + http.readyState);

    if (http.readyState == 4) { // completed?


      //ooooooo
/*
            curItem = new ContentItem();  // not found so add it fresh
            curItem.source = source;
	    curItem.snippet = url;
            curItem.layout = gddContentItemLayoutNews;
            curItem.onDetailsView = OnDetailsView;
            contentArea.addContentItem(curItem, gddItemDisplayInSidebar);
  */    //ooooooo


      // parse the xml data received
      var doc = new DOMDocument();
      doc.loadXML(http.responseText);
     
      // read the word title, description and link from the xml
      var title, desc, link;
      var elem = doc.getElementsByTagName("item");
      if (elem != null && elem.length > 0) {
        for (var node = elem[0].firstChild; node != null; node = node.nextSibling) {
          if (node.nodeName == "title")
            title = node.firstChild.nodeValue;
          if (node.nodeName == "description")
            desc = node.firstChild.nodeValue;
          if (node.nodeName == "link")
            link = node.firstChild.nodeValue;
        }
        desc = desc.replace(/<([^>]|\n)*>/g,'');  // remove html tags if present
        desc = desc.replace(/&nbsp;/g, ' ');
        desc = desc.replace(/&quot;/g, '"');
        desc = desc.replace(/&amp;/g, '&');
        
        var i;
        if ((i = title.indexOf(":")) != -1)
          title = title.substring(0, i);
        if ((i = desc.indexOf(":")) != -1) {
        //  var phrase = desc.substring(0, i);
        //  if (phrase == title) {
            desc = desc.substring(i + 1);
        //  }
        }
      }

      if (title != null) {  // successfully parsed?

	//alert("got title");

        // get the currently shown items and check if our word is in there. If so just
        // update it with the new definition, if not add to the beginning.
        var vbarrItems = contentArea.contentItems;
        if (vbarrItems != null) {
          var items = vbarrItems.toArray();
          for (var i = 0; i < items.length; i++) {
            if (items[i].source == source)
              break;
          }

          var curItem = null;
          if (i == items.length) {
            curItem = new ContentItem();  // not found so add it fresh
            curItem.source = "";//source;
            curItem.layout = gddContentItemLayoutNews;
            curItem.onDetailsView = OnDetailsView;
            contentArea.addContentItem(curItem, gddItemDisplayInSidebar);
          } else {
            curItem = items[i]; // update the existing item
          }
          // update item's data with latest
          str =  desc;
          curItem.heading = title + ":\n";
          curItem.snippet = str;     // to show in details view
          curItem.open_command = link;
        }
      }
      http = null;  // free the http object
    }
  }
}

function OnDetailsView(item) {
  var obj = new Object();
  obj.title = item.heading.substring(0, (item.heading.indexOf(":")));
  // other properties we can set in this object are 'cancel', 'details_control' and
  // 'flags'.
  return obj;
}
